﻿using Infragistics.Controls.Menus;
using Infragistics.DragDrop;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;
using WpfApplication191.ViewModel;

namespace WpfApplication191.Behaviors
{
    public class DragDropBehavior : Behavior<XamDataTree>
    {
        VM vm = Application.Current.Resources["vm"] as VM;
        protected override void OnAttached()
        {
            Style nodeControlStyle = new Style(typeof(XamDataTreeNodeControl));
            nodeControlStyle.Setters.Add(new EventSetter(XamDataTreeNodeControl.LoadedEvent, new RoutedEventHandler(XamDataTreeNodeControl_Loaded)));
            this.AssociatedObject.Resources.Add(typeof(XamDataTreeNodeControl), nodeControlStyle);
        }

        private void XamDataTreeNodeControl_Loaded(object sender, RoutedEventArgs e)
        {
            var nodeControl = sender as XamDataTreeNodeControl;
            if (nodeControl != null)
            {
                DragSource source = new DragSource();
                source.IsDraggable = true;
                source.DragStart += Source_DragStart;
                source.DragOver += Source_DragOver;
                DragDropManager.SetDragSource(nodeControl, source);
                source.Drop += DragSource_Drop;
            }
        }

        private void Source_DragOver(object sender, DragDropMoveEventArgs e)
        {
            Console.WriteLine(e.DropTarget.GetType().ToString());
        }

        League dragDataLeague = new League();
        Team dragDataTeam  = null;
        private void Source_DragStart(object sender, DragDropStartEventArgs e)
        {
            var node = e.DragSource as XamDataTreeNodeControl;
            if (node != null)
            {

                if (node.Node.Data != null && node.Node.Data.GetType() == typeof(League))
                    dragDataLeague = node.Node.Data as League;
                else if (node.Node.Data != null && node.Node.Data.GetType() == typeof(Team))
                {
                    //TO DO
                }
            }
        }

        private void DragSource_Drop(object sender, DropEventArgs e)
        {
            if (e.DropTarget != null && e.DropTarget.GetType() == typeof(ListBox))
            {
                if (dragDataTeam != null)
                {
                    //To DO
                }
                else if (dragDataLeague != null)
                {
                    vm.ListboxLeagues.Add(dragDataLeague);
                   // dragDataLeague = null;
                }
                  
            }
        }
    }
}
